<schema xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:u="utils" xmlns:xsl="https://www.w3.org/1999/XSL/Transform" schemaVersion="iso" queryBinding="xslt2">
	<title>Controlli NSO per il tracciato PEPPOL Order transaction 3.0</title>
	<!-- DEFINIZIONE NAMESPACES -->
	<ns uri="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" prefix="cbc"/>
	<ns uri="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" prefix="cac"/>
	<ns uri="urn:oasis:names:specification:ubl:schema:xsd:OrderResponse-2" prefix="ubl"/>
	<ns uri="http://www.w3.org/2001/XMLSchema" prefix="xs"/>
	<ns uri="utils" prefix="u"/>
	<!-- DEFINIZIONE FUNZIONI -->
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:getPartTokenizeID" as="xs:string">
		<param name="reference" as="xs:string"/>
		<param name="arg" as="xs:integer"/>
		<variable name="listToken" select="tokenize($reference, '#')"/>
		<sequence select="$listToken[$arg]"/>
	</function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:countDelitited" as="xs:integer">
		<param name="reference" as="xs:string"/>
		<variable name="stringList" select="tokenize($reference, '#')"/>
		<sequence select="count($stringList)"/>
	</function>
	<function name="u:validationDate" as="xs:boolean" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string?"/>
		<sequence select="string(normalize-space($arg)) castable as xs:date"/>
	</function>
	<function name="u:checkPIVA" as="xs:integer" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string?"/>
		<sequence select="
				if (not($arg castable as xsd:integer)) 
					then 1
					else ( u:addPIVA($arg,xs:integer(0)) mod 10 )"/>
	</function>
	<function name="u:addPIVA" as="xs:integer" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string"/>
		<param name="pari" as="xs:integer"/>
		<variable name="tappo" select="if (not($arg castable as xsd:integer)) then 0 else 1"/>
		<variable name="mapper" select="if ($tappo = 0) then 0 else 
																		( if ($pari = 1) 
																			then ( xs:integer(substring('0246813579', ( xs:integer(substring($arg,1,1)) +1 ) ,1)) ) 
																			else ( xs:integer(substring($arg,1,1) ) )
																		)"/>
		<sequence select="if ($tappo = 0) then $mapper else ( xs:integer($mapper) + u:addPIVA(substring(xs:string($arg),2), (if($pari=0) then 1 else 0) ) )"/>
	</function>
	<function name="u:checkPIVAseIT" as="xs:boolean" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string"/>
		<variable name="paese" select="substring($arg,1,2)"/>
		<variable name="codice" select="substring($arg,3)"/>
		<sequence select="

			if ( $paese = 'IT' or $paese = 'it' )
			then
			(
				if ( ( string-length($codice) = 11 ) and ( if (u:checkPIVA($codice)!=0) then false() else true() ))
				then 
				(
					true()
				)
				else
				(
					false()
				)
			)
			else
			(
				true()
			)

		"/>
	</function>
	<function name="u:checkCF" as="xs:boolean" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string?"/>
		<sequence select="
			if ( (string-length($arg) = 16) or (string-length($arg) = 11) ) 		
			then 
			(
				if ((string-length($arg) = 16)) 
				then
				(
					if (u:checkCF16($arg)) 
					then
					(
						true()
					)
					else
					(
						false()
					)
				)
				else
				(
					if(($arg castable as xsd:integer)) then true() else false()
	
				)
			)
			else
			(
				false()
			)
			"/>
	</function>
<function name="u:valueOfDigit" as="xs:integer" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="digitCaseSensitive" as="xs:string"/>
		<param name="posit" as="xs:integer"/>
		<variable name="digit" select="upper-case($digitCaseSensitive)"/>
		<sequence select="
					if ( ($digit = '0') or ($digit = 'A'))
					then (
						if(($posit mod 2) = 0) then 0 else 1
					)
					else if ( ($digit = '1') or ($digit = 'B'))
					then (
						if(($posit mod 2) = 0) then 1 else 0
					)
					else if ( ($digit = '2') or ($digit = 'C'))
					then (
						if(($posit mod 2) = 0) then 2 else 5
					)
					else if ( ($digit = '3') or ($digit = 'D'))
					then (
						if(($posit mod 2) = 0) then 3 else 7
					)
					else if ( ($digit = '4') or ($digit = 'E'))
					then (
						if(($posit mod 2) = 0) then 4 else 9
					)
					else if ( ($digit = '5') or ($digit = 'F'))
					then (
						if(($posit mod 2) = 0) then 5 else 13
					)
					else if ( ($digit = '6') or ($digit = 'G'))
					then (
						if(($posit mod 2) = 0) then 6 else 15
					)
					else if ( ($digit = '7') or ($digit = 'H'))
					then (
						if(($posit mod 2) = 0) then 7 else 17
					)
					else if ( ($digit = '8') or ($digit = 'I'))
					then (
						if(($posit mod 2) = 0) then 8 else 19
					)
					else if ( ($digit = '9') or ($digit = 'J'))
					then (
						if(($posit mod 2) = 0) then 9 else 21
					)
					else if ($digit = 'K')
					then (
						if(($posit mod 2) = 0) then 10 else 2
					)
					else if ($digit = 'L')
					then (
						if(($posit mod 2) = 0) then 11 else 4
					)
					else if ($digit = 'M')
					then (
						if(($posit mod 2) = 0) then 12 else 18
					)
					else if ($digit = 'N')
					then (
						if(($posit mod 2) = 0) then 13 else 20
					)
					else if ($digit = 'O')
					then (
						if(($posit mod 2) = 0) then 14 else 11
					)
					else if ($digit = 'P')
					then (
						if(($posit mod 2) = 0) then 15 else 3
					)
					else if ($digit = 'Q')
					then (
						if(($posit mod 2) = 0) then 16 else 6
					)
					else if ($digit = 'R')
					then (
						if(($posit mod 2) = 0) then 17 else 8
					)
					else if ($digit = 'S')
					then (
						if(($posit mod 2) = 0) then 18 else 12
					)
					else if ($digit = 'T')
					then (
						if(($posit mod 2) = 0) then 19 else 14
					)
					else if ($digit = 'U')
					then (
						if(($posit mod 2) = 0) then 20 else 16
					)
					else if ($digit = 'V')
					then (
						if(($posit mod 2) = 0) then 21 else 10
					)
					else if ($digit = 'W')
					then (
						if(($posit mod 2) = 0) then 22 else 22
					)
					else if ($digit = 'X')
					then (
						if(($posit mod 2) = 0) then 23 else 25
					)
					else if ($digit = 'Y')
					then (
						if(($posit mod 2) = 0) then 24 else 24
					)
					else if ($digit = 'Z')
					then (
						if(($posit mod 2) = 0) then 25 else 23
					)
					else 26
					"/>
	</function>
	<function name="u:checkDigit" as="xs:string" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="digit" as="xs:integer"/>
		<sequence select="
					if ($digit = 0) then 'A'
					else if ($digit = 1) then 'B'
					else if ($digit = 2) then 'C'
					else if ($digit = 3) then 'D'
					else if ($digit = 4) then 'E'
					else if ($digit = 5) then 'F'
					else if ($digit = 6) then 'G'
					else if ($digit = 7) then 'H'
					else if ($digit = 8) then 'I'
					else if ($digit = 9) then 'J'
					else if ($digit = 10) then 'K'
					else if ($digit = 11) then 'L'
					else if ($digit = 12) then 'M'
					else if ($digit = 13) then 'N'
					else if ($digit = 14) then 'O'
					else if ($digit = 15) then 'P'
					else if ($digit = 16) then 'Q'
					else if ($digit = 17) then 'R'
					else if ($digit = 18) then 'S'
					else if ($digit = 19) then 'T'
					else if ($digit = 20) then 'U'
					else if ($digit = 21) then 'V'
					else if ($digit = 22) then 'W'
					else if ($digit = 23) then 'X'
					else if ($digit = 24) then 'Y'
					else if ($digit = 25) then 'Z'
					else '0'
					"/>
	</function>	
	<function name="u:checkCF16" as="xs:boolean" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string?"/>
		<sequence select="
					if(matches($arg, '^[A-Za-z]{6}[0-9LMNPQRSTUVlmnpqrstuv]{2}[ABCDEHLMPRSTabcdehlmprst]{1}[0-9LMNPQRSTUVlmnpqrstuv]{2}[A-Za-z]{1}[0-9LMNPQRSTUVlmnpqrstuv]{3}[A-Za-z]{1}$'))
					then
					(
						if(
							u:checkDigit((
								u:valueOfDigit(substring($arg,1,1), 1) + u:valueOfDigit(substring($arg,2,1), 2) +
								u:valueOfDigit(substring($arg,3,1), 3) + u:valueOfDigit(substring($arg,4,1), 4) +
								u:valueOfDigit(substring($arg,5,1), 5) + u:valueOfDigit(substring($arg,6,1), 6) +
								u:valueOfDigit(substring($arg,7,1), 7) + u:valueOfDigit(substring($arg,8,1), 8) +
								u:valueOfDigit(substring($arg,9,1), 9) + u:valueOfDigit(substring($arg,10,1), 10) +
								u:valueOfDigit(substring($arg,11,1), 11) + u:valueOfDigit(substring($arg,12,1), 12) +
								u:valueOfDigit(substring($arg,13,1), 13) + u:valueOfDigit(substring($arg,14,1), 14) +
								u:valueOfDigit(substring($arg,15,1), 15)
							) mod 26) = upper-case(substring($arg,16,1))
						)
						then true()
						else false()
					)
					else false()
					"/>
	</function>
	<function name="u:checkCF11" as="xs:boolean" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string?"/>
		<sequence select="
					if ( ($arg castable as xsd:integer) and (string-length($arg) = 11) ) 
					then true()
					else false()
					"/>
	</function>
	<function name="u:checkCodiceIPA" as="xs:boolean" xmlns="http://www.w3.org/1999/XSL/Transform">
		<param name="arg" as="xs:string?"/>
		<variable name="allowed-characters">ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789</variable>
		<sequence select="if ( (string-length(translate($arg, $allowed-characters, '')) = 0) and (string-length($arg) = 6) ) then true() else false()"/>
	</function>
	<!-- DEFINIZIONE PHASE -->
	<phase id="underConstruction">
		<active pattern="verificaOrderReferenceID"/>
		<active pattern="verificaPIVA"/>
		<active pattern="verificaLinee"/>
		<active pattern="verificaCodiceIPA"/>
		<active pattern="verificaBuyer"/>
		<active pattern="verificaCF"/>
	</phase>
	<!-- DEFINIZIONE ABSTRACT ROLE PATTERN -->
	<pattern id="Abstract">
		<rule abstract="true" id="verifica_codice_ipa">
			<assert id="NSO_110" test="if(@schemeID=0201) then u:checkCodiceIPA(.) else true()" flag="fatal">NSO_110 - Il Codice IPA indicato nell’elemento non è valido. - The IPA Code specified in the element is invalid.
			</assert>
		</rule>
	</pattern>
	<!-- DEFINIZIONE PATTERN NELLA PHASE verificaOrderReferenceID -->
	<pattern id="verificaOrderReferenceID">
		<rule context="ubl:OrderResponse">
			<assert id="NSO_145" test="count(/ubl:OrderResponse/cac:OrderReference) = 1" flag="fatal">
				NSO_145 - Il Documento contiene più di un elemento "cac:OrderReference". - The Document contains more than one "cac:OrderReference" element. 
			</assert>
		</rule>
		<!-- Verifica struttura cac:OrderReference/cbc:ID -->
		<rule context="cac:OrderReference">
			<assert id="NSO_140" test="(u:countDelitited(cbc:ID) eq 3)" flag="fatal">
				NSO_140 - Il formato dell elemento "cac:OrderReference/cbc:ID" non e valido (esempio di formato corretto: "110#2018-01-30#QLHCFC "). - The format of the element "cac:OrderReference/cbc:ID" is invalid (correct format example:"110#2018-01-30#QLHCFC"). 
			</assert>
			<assert id="NSO_141" test="if((u:countDelitited(cbc:ID)=3)) then ( (u:getPartTokenizeID(cbc:ID,1)!='') ) else true()" flag="fatal">
				NSO_141 - L'ID presente nell elemento non e valorizzato. - The ID in the element is not set.
			</assert>
			<assert id="NSO_142" test="if( (u:countDelitited(cbc:ID)=3) and ( (string-length(u:getPartTokenizeID(cbc:ID,2))) > 0) ) then ( u:validationDate(u:getPartTokenizeID(cbc:ID,2)) ) else true()" flag="fatal">
				NSO_142 - Il formato della data presente nell elemento non e corretto (esempio corretto: "2020-01-31"). - The format of the date in the element is incorrect (correct format example: "2020-01-31").
			</assert>
			<assert id="NSO_143" test="if( (u:countDelitited(cbc:ID)=3) and ( (string-length(u:getPartTokenizeID(cbc:ID,3))) > 0)  ) then ( (u:checkCodiceIPA(u:getPartTokenizeID(cbc:ID,3))) ) else true()" flag="fatal">
				NSO_143 - L'EndpointID indicato nell’elemento non è un valore valido (esempio di valore corretto: "QLHCFC"). - The EndpointID specified in the element  is not a valid value (correct value example: "QLHCFC").
			</assert>
		</rule>
	</pattern>
	<pattern id="verificaPIVA">
		<rule context="ubl:OrderResponse/cac:SellerSupplierParty/cac:Party/cbc:EndpointID">
			<assert id="NSO_130" test="if(@schemeID=9906 or @schemeID=0211) then ( if(u:checkPIVA(substring(.,3,13))!=0) then false() else true() ) else true()" flag="fatal">
					NSO_130 - La partita IVA indicata nell’elemento non è valida. - The VAT number specified in the element is invalid.
			</assert>
		</rule>
	</pattern>
	<pattern id="verificaLinee">
		<rule context="ubl:OrderResponse">
			<assert id="NSO_150" test="( if (/ubl:OrderResponse/cbc:OrderResponseCode = 'CA') then ( if (count(/ubl:OrderResponse/cac:OrderLine)=0) then false() else true() ) else ( if (count(/ubl:OrderResponse/cac:OrderLine)=0) then true() else false() ) )" flag="fatal">
				NSO_150 - Il Documento deve contenere uno o piu elementi "cac:OrderLine" solo se si tratta di una Risposta con modifica. - The Document must contain one or more "cac:OrderLine" elements only in Order response with change.
			</assert>
		</rule>
	</pattern>
	<!-- DEFINIZIONE PATTERN NELLA PHASE verificaCodiceIPA -->
	<pattern id="verificaCodiceIPA">
		<rule context="/ubl:OrderResponse/cac:SellerSupplierParty/cac:Party/cac:PartyIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:BuyerCustomerParty/cac:Party/cac:PartyIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:OrderLine/cac:LineItem/cac:Item/cac:StandardItemIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:OrderLine/cac:SellerSubstitutedLineItem/cac:Item/cac:StandardItemIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:SellerSupplierParty/cac:Party/cbc:EndpointID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:BuyerCustomerParty/cac:Party/cbc:EndpointID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:OriginatorCustomerParty/cac:Party/cac:PartyIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:AccountingCustomerParty/cac:Party/cac:PartyIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
		<rule context="/ubl:OrderResponse/cac:Delivery/cac:DeliveryParty/cac:PartyIdentification/cbc:ID">
			<extends rule="verifica_codice_ipa"/>
		</rule>
	</pattern>
	<pattern id="verificaBuyer">
		<rule context="/ubl:OrderResponse/cac:BuyerCustomerParty/cac:Party/cbc:EndpointID">
			<assert id="NSO_111" test="if(@schemeID=0201) then true() else false()" flag="fatal">NSO_111 - Il valore dell’attributo schemeID dell’elemento è errato (il valore corretto è "0201"). - The value of schemeID attribute of the element is incorrect (the correct value is "0201").
			</assert>
		</rule>
	</pattern>
	<pattern id="verificaCF">
		<rule context="/ubl:OrderResponse/cac:SellerSupplierParty/cac:Party/cbc:EndpointID">
			<assert id="NSO_120" test="if(@schemeID=9907 or @schemeID=0210) then u:checkCF(.) else true()" flag="fatal">NSO_120 - Il Codice Fiscale indicato nell’elemento non è valido. - The Tax Code specified in the element is invalid.
			</assert>
		</rule>
	</pattern>
	<pattern id="controllo_lineitem_id">
		<rule context="cac:LineItem">
			<extends rule="define_tipologia_ordine"/>
			<assert id="NSO_164" test="( (string-length(cbc:ID) lt 6) )" flag="warning">NSO_164 - E' consigliabile che la lunghezza dell’identificativo della linea d'ordine non sia maggiore di 6. - Element 'cbc:ID' SHOULD have a maximum length of 6 characters.
			</assert>
		</rule>
	</pattern>
	<pattern xmlns:ns2="http://www.schematron-quickfix.com/validator/process">
		<let name="clUNCL5305" value="tokenize('AE E S Z G O K L M', '\s')"/>
		<rule context="/ubl:OrderResponse/cac:OrderLine/cac:SellerSubstitutedLineItem/cac:Item/cac:ClassifiedTaxCategory/cbc:ID">
			<assert test="(some $code in $clUNCL5305 satisfies $code = normalize-space(text()))" flag="fatal" id="NSO_170">NSO_170 - Il valore DEVE far parte della codifica 'Duty or tax or fee category code (UNCL5305)'. - Value MUST be part of code list 'Duty or tax or fee category code (UNCL5305)'.</assert>
		</rule>
	</pattern>
</schema>